Index: vi/v_txt.c
Prereq: 	10.87 
*** nvi-1.79/vi/v_txt.c	Mon Oct 14 03:25:23 1996
--- nvi-1.79-m17n/vi/v_txt.c	Mon Jun 16 11:21:40 1997
***************
*** 30,35 ****
--- 30,38 ----
  #include "../common/common.h"
  #include "vi.h"
  
+ /* for CS_RAW0 */
+ #include "../common/multibyte.h"
+ 
  static int	 txt_abbrev __P((SCR *, TEXT *, CHAR_T *, int, int *, int *));
  static void	 txt_ai_resolve __P((SCR *, TEXT *, int *));
  static TEXT	*txt_backup __P((SCR *, TEXTH *, TEXT *, u_int32_t *));
***************
*** 40,45 ****
--- 43,51 ----
  static int	 txt_fc_col __P((SCR *, int, ARGS **));
  static int	 txt_hex __P((SCR *, TEXT *));
  static int	 txt_insch __P((SCR *, TEXT *, CHAR_T *, u_int));
+ #ifdef MULTIBYTE
+ static int	 txt_insmbch __P((SCR *, TEXT *, CHAR_T *, u_int));
+ #endif
  static int	 txt_isrch __P((SCR *, VICMD *, TEXT *, u_int8_t *));
  static int	 txt_map_end __P((SCR *));
  static int	 txt_map_init __P((SCR *));
***************
*** 281,287 ****
--- 287,305 ----
  	int showmatch;		/* Showmatch set on this character. */
  	int wm_set, wm_skip;	/* Wrapmargin happened, blank skip flags. */
  	int max, tmp;
+ #ifndef MULTIBYTE
  	char *p;
+ #else
+ 	CHAR_T *p;
+ #endif
+ #ifdef MULTIBYTE
+ 	CHAR_T mbbuf[20];
+ 	CHAR_T mbbuflen;
+ 	CHAR_T mbbufmax;
+ 	size_t mbtmp;
+ 
+ 	mbbuflen = mbbufmax = 0;
+ #endif /*MULTIBYTE*/
  
  	gp = sp->gp;
  	vip = VIP(sp);
***************
*** 332,339 ****
--- 350,364 ----
  	 */
  	if (len) {
  		if (LF_ISSET(TXT_OVERWRITE)) {
+ #ifndef MULTIBYTE
  			tp->owrite = (tm->cno - tp->cno) + 1;
  			tp->insert = (len - tm->cno) - 1;
+ #else
+ 			tp->owrite = (tm->cno - tp->cno)
+ 				+ KEY_BLEN(sp, tp->lb[tm->cno]);
+ 			tp->insert = (len - tm->cno)
+ 				- KEY_BLEN(sp, tp->lb[tm->cno]);
+ #endif /*MULTIBYTE*/
  		} else
  			tp->insert = len - tp->cno;
  
***************
*** 532,537 ****
--- 557,568 ----
  		goto k_escape;
  	}
  
+ #ifdef MULTIBYTE
+ 	/* multibyte chars must go through */
+ 	if (mbbufmax)
+ 		evp->e_value = 0;
+ #endif /*MULTIBYTE*/
+ 
  	/*
  	 * !!!
  	 * If the first character of the input is a nul, replay the previous
***************
*** 918,925 ****
  		 * Set the return cursor position to rest on the last
  		 * inserted character.
  		 */
! 		if (tp->cno != 0)
  			--tp->cno;
  
  		/* Update the last line. */
  		if (vs_change(sp, tp->lno, LINE_RESET))
--- 949,961 ----
  		 * Set the return cursor position to rest on the last
  		 * inserted character.
  		 */
! 		if (tp->cno != 0) {
! #ifndef MULTIBYTE
  			--tp->cno;
+ #else
+ 			tp->cno -= multi_back(sp, tp->lb, &tp->lb[tp->cno]);
+ #endif
+ 		}
  
  		/* Update the last line. */
  		if (vs_change(sp, tp->lno, LINE_RESET))
***************
*** 1007,1013 ****
--- 1043,1054 ----
  		}
  
  		/* Drop back one character. */
+ #ifndef MULTIBYTE
  		--tp->cno;
+ #else
+ 		mbtmp = multi_back(sp, tp->lb, &tp->lb[tp->cno]);
+ 		tp->cno -= mbtmp;
+ #endif /*MULTIBYTE*/
  
  		/*
  		 * Historically, vi didn't replace the erased characters with
***************
*** 1019,1026 ****
  		 * point in the screen.  So, if incrementally searching, erase
  		 * the erased characters from the screen.
  		 */
! 		if (FL_ISSET(is_flags, IS_RUNNING))
  			tp->lb[tp->cno] = ' ';
  
  		/*
  		 * Increment overwrite, decrement ai if deleted.
--- 1060,1076 ----
  		 * point in the screen.  So, if incrementally searching, erase
  		 * the erased characters from the screen.
  		 */
! 		if (FL_ISSET(is_flags, IS_RUNNING)) {
! #ifndef MULTIBYTE
  			tp->lb[tp->cno] = ' ';
+ #else
+ 			size_t off, blen;
+ 
+ 			blen = KEY_BLEN(sp, tp->lb[tp->cno]);
+ 			for (off = 0; off < blen; off++)
+ 				tp->lb[tp->cno + off] = ' ';
+ #endif /*MULTIBYTE*/
+ 		}
  
  		/*
  		 * Increment overwrite, decrement ai if deleted.
***************
*** 1030,1038 ****
--- 1080,1094 ----
  		 * to delete autoindent characters.  We do.  Eat hot death,
  		 * POSIX.
  		 */
+ #ifndef MULTIBYTE
  		++tp->owrite;
  		if (tp->cno < tp->ai)
  			--tp->ai;
+ #else
+ 		tp->owrite += mbtmp;
+ 		if (tp->cno < tp->ai)
+ 			tp->ai -= mbtmp;
+ #endif
  
  		/* Reset if we deleted an incremental search character. */
  		if (FL_ISSET(is_flags, IS_RUNNING))
***************
*** 1102,1108 ****
  		 * Overwrite erased characters if doing incremental search;
  		 * see comment above.
  		 */
! 		if (LF_ISSET(TXT_TTYWERASE))
  			while (tp->cno > max) {
  				--tp->cno;
  				++tp->owrite;
--- 1158,1165 ----
  		 * Overwrite erased characters if doing incremental search;
  		 * see comment above.
  		 */
! 		if (LF_ISSET(TXT_TTYWERASE)) {
! #ifndef MULTIBYTE
  			while (tp->cno > max) {
  				--tp->cno;
  				++tp->owrite;
***************
*** 1111,1125 ****
  				if (isblank(tp->lb[tp->cno - 1]))
  					break;
  			}
! 		else {
  			if (LF_ISSET(TXT_ALTWERASE)) {
  				--tp->cno;
  				++tp->owrite;
  				if (FL_ISSET(is_flags, IS_RUNNING))
  					tp->lb[tp->cno] = ' ';
  				if (isblank(tp->lb[tp->cno - 1]))
  					break;
  			}
  			if (tp->cno > max)
  				tmp = inword(tp->lb[tp->cno - 1]);
  			while (tp->cno > max) {
--- 1168,1217 ----
  				if (isblank(tp->lb[tp->cno - 1]))
  					break;
  			}
! #else
! 			size_t blen;
! 			size_t off;
! 
! 			blen = multi_back(sp, tp->lb, &tp->lb[tp->cno]);
! 			while (tp->cno > max) {
! 				tp->cno -= blen;
! 				tp->owrite += blen;
! 				if (FL_ISSET(is_flags, IS_RUNNING)) {
! 					for (off = 0; off < blen; off++)
! 						tp->lb[tp->cno + off] = ' ';
! 				}
! 				off = multi_back(sp, tp->lb, &tp->lb[tp->cno]);
! 				if (isblank(tp->lb[tp->cno - off]))
! 					break;
! 				blen = off;
! 			}
! #endif /*MULTIBYTE*/
! 		} else {
  			if (LF_ISSET(TXT_ALTWERASE)) {
+ #ifndef MULTIBYTE
  				--tp->cno;
  				++tp->owrite;
  				if (FL_ISSET(is_flags, IS_RUNNING))
  					tp->lb[tp->cno] = ' ';
  				if (isblank(tp->lb[tp->cno - 1]))
  					break;
+ #else
+ 				size_t blen;
+ 				size_t off;
+ 
+ 				blen = multi_back(sp, tp->lb, &tp->lb[tp->cno]);
+ 				tp->cno -= blen;
+ 				tp->owrite += blen;
+ 				if (FL_ISSET(is_flags, IS_RUNNING)) {
+ 					for (off = 0; off < blen; off++)
+ 						tp->lb[tp->cno + off] = ' ';
+ 				}
+ 				blen = multi_back(sp, tp->lb, &tp->lb[tp->cno]);
+ 				if (isblank(tp->lb[tp->cno - blen]))
+ 					break;
+ #endif /*MULTIBYTE*/
  			}
+ #ifndef MULTIBYTE
  			if (tp->cno > max)
  				tmp = inword(tp->lb[tp->cno - 1]);
  			while (tp->cno > max) {
***************
*** 1131,1136 ****
--- 1223,1270 ----
  				    || isblank(tp->lb[tp->cno - 1]))
  					break;
  			}
+ #else
+ 		    {
+ 			size_t blen;
+ 			size_t off;
+ 
+ 			blen = multi_back(sp, tp->lb, &tp->lb[tp->cno]);
+ 			if (blen == 1) {
+ 				if (tp->cno > max)
+ 					tmp = inword(tp->lb[tp->cno - 1]);
+ 				while (tp->cno > max) {
+ 					--tp->cno;
+ 					++tp->owrite;
+ 					if (FL_ISSET(is_flags, IS_RUNNING))
+ 						tp->lb[tp->cno] = ' ';
+ 					blen = multi_back(sp, tp->lb,
+ 						&tp->lb[tp->cno]);
+ 					if (1 < blen)
+ 						break;
+ 					if (tmp != inword(tp->lb[tp->cno - 1])
+ 					    || isblank(tp->lb[tp->cno - 1]))
+ 						break;
+ 				}
+ 			} else {
+ 				u_int ochclass, chclass;
+ 
+ 				if (tp->cno > max)
+ 					ochclass = multi_chclass(&tp->lb[tp->cno - blen], 0);
+ 				while (tp->cno > max) {
+ 					tp->cno -= blen;
+ 					tp->owrite += blen;
+ 					if (FL_ISSET(is_flags, IS_RUNNING)) {
+ 						for (off = 0; off < blen; off++)
+ 							tp->lb[tp->cno + off] = ' ';
+ 					}
+ 					blen = multi_back(sp, tp->lb, &tp->lb[tp->cno]);
+ 					chclass = multi_chclass(&tp->lb[tp->cno - blen], ochclass);
+ 					if (multi_wordbound(ochclass, chclass, 0))
+ 						break;
+ 				}
+ 			}
+ 		    }
+ #endif
  		}
  
  		/* Reset if we deleted an incremental search character. */
***************
*** 1247,1252 ****
--- 1381,1447 ----
  		hexcnt = 1;
  		goto insq_ch;
  	default:			/* Insert the character. */
+ #ifdef MULTIBYTE
+ 		if (!mbbufmax) {
+ 			if (!(evp->e_c & 0x80))
+ 				goto ins_ch;
+ 
+ 			/*
+ 			 * start buffering multibyte chars.
+ 			 */
+ 			mbbuflen = 0;
+ 			mbbufmax = KEY_BLEN(sp, evp->e_c);
+ 			mbbuf[mbbuflen++] = evp->e_c;
+ 			mbbuf[mbbuflen] = '\0';
+ 		} else {
+ 			/*
+ 			 * multibyte chars must go through.
+ 			 */
+ 			if (mbbufmax < mbbuflen)
+ 				abort();
+ 			mbbuf[mbbuflen++] = evp->e_c;
+ 			mbbuf[mbbuflen] = '\0';
+ 			if (mbbuflen == mbbufmax) {
+ 				mbbufmax = mbbuflen = 0;
+ 				goto ins_mbch;
+ 			}
+ 		}
+ 		break;
+ 
+ 		/*
+ 		 * Insert multibyte char.
+ 		 */
+ ins_mbch:	if (txt_insmbch(sp, tp, mbbuf, flags))
+ 			goto err;
+ 
+ 		/*
+ 		 * Check to see if we've crossed the margin.
+ 		 *
+ 		 * !!!
+ 		 * In the historic vi, the wrapmargin value was figured out
+ 		 * using the display widths of the characters, i.e. <tab>
+ 		 * characters were counted as two characters if the list edit
+ 		 * option is set, but as the tabstop edit option number of
+ 		 * characters otherwise.  That's what the vs_column() function
+ 		 * gives us, so we use it.
+ 		 */
+ 		if (margin != 0) {
+ 			if (vs_column(sp, &tcol))
+ 				goto err;
+ 			if (tcol >= margin) {
+ 				if (txt_margin(sp, tp, &wmt, &tmp, flags))
+ 					goto err;
+ 				if (tmp) {
+ 					if (isblank(evp->e_c))
+ 						wm_skip = 1;
+ 					wm_set = 1;
+ 					goto k_cr;
+ 				}
+ 			}
+ 		}
+ 
+ 		goto ebuf_chk;
+ #endif /*MULTIBYTE*/
  ins_ch:		/*
  		 * Historically, vi eliminated nul's out of hand.  If the
  		 * beautify option was set, it also deleted any unknown
***************
*** 1475,1480 ****
--- 1670,1678 ----
  	CHAR_T ch, *p;
  	SEQ *qp;
  	size_t len, off;
+ #ifdef MULTIBYTE
+ 	size_t mback;
+ #endif
  
  	/* Check to make sure we're not at the start of an append. */
  	*didsubp = 0;
***************
*** 1503,1522 ****
--- 1701,1742 ----
  	 * Terminate at the beginning of the insert or the character after the
  	 * offset character -- both can be tested for using tp->offset.
  	 */
+ #ifndef MULTIBYTE
  	off = tp->cno - 1;			/* Previous character. */
+ #else
+ 	off = tp->cno - multi_back(sp, tp->lb, &tp->lb[tp->cno]);
+ 						/* Previous character. */
+ #endif /*MULTIBYTE*/
  	p = tp->lb + off;
  	len = 1;				/* One character test. */
  	if (off == tp->offset || isblank(p[-1]))
  		goto search;
+ #ifndef MULTIBYTE
  	if (inword(p[-1]))			/* Move backward to change. */
+ #else
+ 	if (multi_back(sp, tp->lb, p) == 1 && inword(p[-1]))
+ #endif
  		for (;;) {
  			--off; --p; ++len;
+ #ifdef MULTIBYTE
+ 			if (1 < multi_back(sp, tp->lb, p))
+ 				break;
+ #endif /*MULTIBYTE*/
  			if (off == tp->offset || !inword(p[-1]))
  				break;
  		}
  	else
  		for (;;) {
+ #ifndef MULTIBYTE
  			--off; --p; ++len;
+ #else
+ 			mback = multi_back(sp, tp->lb, p);
+ 			off -= mback;
+ 			p -= mback;
+ 			len += mback;
+ 			if (1 < multi_back(sp, tp->lb, p))
+ 				break;
+ #endif /*MULTIBYTE*/
  			if (off == tp->offset ||
  			    inword(p[-1]) || isblank(p[-1]))
  				break;
***************
*** 1641,1647 ****
--- 1861,1871 ----
  	u_int32_t *ec_flagsp;
  {
  	size_t len, off;
+ #ifndef MULTIBYTE
  	char *p;
+ #else
+ 	CHAR_T *p;
+ #endif
  
  	/* Find the beginning of this "word". */
  	for (off = tp->cno - 1, p = tp->lb + off, len = 0;; --p, --off) {
***************
*** 1686,1692 ****
--- 1910,1920 ----
  	u_long ts;
  	int del;
  	size_t cno, len, new, old, scno, spaces, tab_after_sp, tabs;
+ #ifndef MULTIBYTE
  	char *p;
+ #else
+ 	CHAR_T *p;
+ #endif
  
  	*changedp = 0;
  
***************
*** 1775,1781 ****
--- 2003,2013 ----
  	size_t len;
  {
  	size_t nlen;
+ #ifndef MULTIBYTE
  	char *p, *t;
+ #else
+ 	CHAR_T *p, *t;
+ #endif
  
  	if (aitp == NULL) {
  		/*
***************
*** 2014,2020 ****
--- 2246,2256 ----
  	EXCMD cmd;
  	size_t indx, len, nlen, off;
  	int argc, trydir;
+ #ifndef MULTIBYTE
  	char *p, *t;
+ #else
+ 	CHAR_T *p, *t;
+ #endif
  
  	trydir = 0;
  	*redrawp = 0;
***************
*** 2278,2287 ****
--- 2514,2562 ----
  {
  	CHAR_T ch, *kp;
  	size_t chlen, nlen, olen;
+ #ifndef MULTIBYTE
  	char *p;
+ #else
+ 	CHAR_T *p;
+ #endif
  
  	ch = CH_ENDMARK;
  
+ #ifdef MULTIBYTE
+ 	/*
+ 	 * Multibyte case.
+ 	 * We do need to care about multibyte chars.  Hard one.
+ 	 * We don't change screen width by filling the character by set of $s.
+ 	 * We might need to change buffer for that.
+ 	 *
+ 	 *	appearance			buffer
+ 	 *	---				--
+ 	 *	n = KEY_LEN(sp, tp->lb[cno])	KEY_BLEN(sp, tp->lb[cno])
+ 	 *	  v				  v
+ 	 *	1 * n				1 * n
+ 	 */
+ 	if (1 < KEY_BLEN(sp, tp->lb[cno])) {
+ 		size_t nblen, oblen;
+ 		nlen = olen = KEY_LEN(sp, tp->lb[cno]);
+ 		nblen = KEY_LEN(sp, tp->lb[cno]);
+ 		oblen = KEY_BLEN(sp, tp->lb[cno]);
+ 
+ 		if (nblen != oblen) {
+ 			BINC_RET(sp, tp->lb, tp->lb_len, tp->len - oblen + nblen);
+ 			if (tp->insert != 0)
+ 				memmove(tp->lb + cno + nblen,
+ 					tp->lb + cno + oblen, tp->insert);
+ 	
+ 			tp->len += (nblen - oblen);
+ 			tp->owrite += (nblen - oblen);
+ 		}
+ 		for (chlen = 0; chlen < nblen; chlen++)
+ 			tp->lb[cno + chlen] = ch;
+ 		
+ 		goto done;
+ 	}
+ #endif /*MULTIBYTE*/
+ 
  	/*
  	 * The end mark may not be the same size as the current character.
  	 * Don't let the line shift.
***************
*** 2315,2321 ****
--- 2590,2600 ----
  			    cno += chlen; chlen--;)
  				*p++ = *kp++;
  	}
+ 
  	tp->lb[cno] = ch;
+ #ifdef MULTIBYTE
+ done:
+ #endif
  	return (vs_change(sp, tp->lno, LINE_RESET));
  }
  
***************
*** 2405,2411 ****
--- 2684,2692 ----
  	/* Adjust the bookkeeping. */
  	tp->cno -= len;
  	tp->len -= len;
+ #ifndef MULTIBYTE
  	tp->lb[tp->cno - 1] = value;
+ #endif
  
  	/* Copy down any overwrite characters. */
  	if (tp->owrite)
***************
*** 2416,2421 ****
--- 2697,2713 ----
  		memmove(tp->lb + tp->cno + tp->owrite,
  		    tp->lb + tp->cno + tp->owrite + len, tp->insert);
  
+ #ifdef MULTIBYTE
+ 	if (value & 0x80) {
+ 		CHAR_T ch;
+ 		ch = ' ';
+ 		(void)txt_insch(sp, tp, &ch, 0);
+ 		tp->lb[tp->cno - 2] = CS_RAW0 + v_key_len(sp, value);
+ 		tp->lb[tp->cno - 1] = value & 0x7f;
+ 	} else
+ 		tp->lb[tp->cno - 1] = value & 0x7f;
+ #endif
+ 
  	return (0);
  }
  
***************
*** 2438,2443 ****
--- 2730,2736 ----
   * vi overwrite characters the user has committed to changing, on the basis
   * of the screen space they require, but that it not overwrite other characters.
   */
+ #ifndef MULTIBYTE
  static int
  txt_insch(sp, tp, chp, flags)
  	SCR *sp;
***************
*** 2549,2554 ****
--- 2842,3042 ----
  	tp->lb[tp->cno++] = *chp;
  	return (0);
  }
+ #else
+ static int
+ txt_insch(sp, tp, chp, flags)
+ 	SCR *sp;
+ 	TEXT *tp;
+ 	CHAR_T *chp;
+ 	u_int flags;
+ {
+ 	CHAR_T buf[2];
+ 	
+ 	buf[0] = *chp;
+ 	buf[1] = '\0';
+ 	return txt_insmbch(sp, tp, buf, flags);
+ }
+ 
+ static int
+ txt_insmbch(sp, tp, chp, flags)
+ 	SCR *sp;
+ 	TEXT *tp;
+ 	CHAR_T *chp;
+ 	u_int flags;
+ {
+ 	CHAR_T *kp, savech;
+ 	size_t chlen, cno, olen, nlen;
+ 	char *p;
+ 	size_t oblen, nblen;
+ 	size_t owriteblen, owritelen;
+ 
+ 	nblen = KEY_BLEN(sp, chp[0]);
+ 	owriteblen = owritelen = 0;
+ 	/*
+ 	 * What we have to care about:
+ 	 * 1. relationship between nblen and owrite.
+ 	 *	a. if owrite = 0, that's fine.
+ 	 *	b. if nblen < owrite, that's fine too.
+ 	 *	c. if owrite < nblen, it would be very hard.
+ 	 */
+ 	/*
+ 	 * The 'R' command does one-for-one replacement, because there's
+ 	 * no way to know how many characters the user intends to replace.
+ 	 */
+ 	if (LF_ISSET(TXT_REPLACE)) {
+ 		if (tp->owrite) {
+ 			oblen = KEY_BLEN(sp, tp->lb[tp->cno]);
+ 			if (tp->owrite < oblen) {
+ 				/*
+ 				 * Seems illegal.  Part of multibyte char
+ 				 * is target for overwrite.
+ 				 * We die for now.
+ 				 */
+ 				abort();
+ 			}
+ 			
+ 			/*
+ 			 * Adjust buffer since the currently existing char
+ 			 * has different bytewidth with the overwriting one.
+ 			 */
+ 			if (oblen != nblen) {
+ 				if (oblen < nblen) {
+ 					BINC_RET(sp, tp->lb, tp->lb_len,
+ 						tp->len + (nblen - oblen));
+ 				}
+ 				memmove(tp->lb + tp->cno + nblen,
+ 					tp->lb + tp->cno + oblen,
+ 					tp->len - tp->cno - oblen);
+ 				tp->len += (nblen - oblen);
+ 			}
+ 			
+ 			/*
+ 			 * Let me overwrite.
+ 			 */
+ 			tp->owrite -= oblen;
+ 			memmove(&tp->lb[tp->cno], chp, nblen);
+ 			tp->cno += nblen;
+ 			return 0;
+ 		}
+ 	} else if (tp->owrite) {		/* Overwrite a character. */
+ 		cno = tp->cno;
+ 	
+ 		/*
+ 		 * If the old or new characters are tabs, then the length of the
+ 		 * display depends on the character position in the display.  We
+ 		 * don't even try to handle this here, just ask the screen.
+ 		 */
+ 		if (*chp == '\t') {
+ 			savech = tp->lb[cno];
+ 			tp->lb[cno] = '\t';
+ 			(void)vs_columns(sp, tp->lb, tp->lno, &cno, &nlen);
+ 			tp->lb[cno] = savech;
+ 		} else
+ 			nlen = KEY_LEN(sp, *chp);
+ 
+ 		/*
+ 		 * Eat overwrite characters until we run out of them or we've
+ 		 * handled the length of the new character.  If we only eat
+ 		 * part of an overwrite character, break it into its component
+ 		 * elements and display the remaining components.
+ 		 */
+ 		while (owritelen < nlen && owriteblen < tp->owrite) {
+ 			/*
+ 			 * Set oblen and olen by the current char.
+ 		 	 */
+ 			oblen = KEY_BLEN(sp, tp->lb[cno]);
+ 			if (tp->lb[cno] == '\t')
+ 				(void)vs_columns(sp,
+ 				    tp->lb, tp->lno, &cno, &olen);
+ 			else
+ 				olen = KEY_LEN(sp, tp->lb[cno]);
+ 
+ 			if (tp->owrite - owriteblen < oblen) {
+ 				/*
+ 				 * Seems illegal.  Part of multibyte char
+ 				 * is target for overwrite.
+ 				 * We die for now.
+ 				 */
+ 				abort();
+ 			}
+ 
+ 			if (olen <= nlen - owritelen) {
+ 				/*
+ 				 * We will overwrite this character as a whole.
+ 				 * Continue overwrite toward next char.
+ 				 */
+ 				owritelen += olen;
+ 				owriteblen += oblen;
+ 				cno += oblen;
+ 				continue;
+ 			}
+ 
+ 			/*
+ 			 * We must partially overwrite this character.
+ 			 * Split the current char into single-bytes.
+ 			 * 
+ 			 *		before		after
+ 			 *		---		---
+ 			 * LEN		olen		olen
+ 			 * BLEN		oblen		olen
+ 			 */
+ 			if (oblen < olen) {
+ 				BINC_RET(sp, tp->lb, tp->lb_len,
+ 					tp->len + olen - oblen);
+ 			}
+ 			memmove(tp->lb + cno + olen, tp->lb + cno + oblen,
+ 				tp->owrite - oblen + tp->insert);
+ 			tp->len += (olen - oblen);
+ 			tp->owrite += (olen - oblen);
+ 
+ 			if (tp->lb[cno] == '\t' || 1 < oblen) {
+ 				p = tp->lb + cno;
+ 				for (chlen = 0; chlen < olen; chlen++)
+ 					*p++ = ' ';
+ 			} else {
+ 				p = tp->lb + cno;
+ 				kp = KEY_NAME(sp, tp->lb[cno]);
+ 				for (chlen = 0; chlen < olen; chlen++)
+ 					*p++ = *kp++;
+ 			}
+ 
+ 			cno += (nlen - owritelen);
+ 			owriteblen += (nlen - owritelen);
+ 			owritelen = nlen;
+ 		}
+ 
+ 		/*
+ 		 * If we had enough overwrite characters, we're done.
+ 		 * simply overwrite that.
+ 		 */
+ 		if (nlen == owritelen) {
+ 			memmove(tp->lb + tp->cno + nblen,
+ 				tp->lb + tp->cno + owriteblen,
+ 				tp->owrite - owriteblen + tp->insert);
+ 			tp->len += (nblen - owriteblen);
+ 			memcpy(tp->lb + tp->cno, chp, nblen);
+ 			tp->cno += nblen;
+ 			tp->owrite -= owriteblen;
+ 			return 0;
+ 		}
+ 	}
+ 
+ 	/* Check to see if the character fits into the input buffer. */
+ 	if (owritelen < nblen)
+ 		BINC_RET(sp, tp->lb, tp->lb_len, tp->len + nblen - owriteblen);
+ 
+ 	if (tp->insert) {			/* Insert a character. */
+ 		memmove(tp->lb + tp->cno + nblen,
+ 			tp->lb + tp->cno + owriteblen,
+ 			tp->owrite - owriteblen + tp->insert);
+ 	}
+ 	memcpy(tp->lb + tp->cno, chp, nblen);
+ 	tp->cno += nblen;
+ 	tp->owrite -= owriteblen;
+ 	tp->len += (nblen - owriteblen);
+ 	return 0;
+ }
+ #endif /*MULTIBYTE*/
  
  /*
   * txt_isrch --
***************
*** 2743,2749 ****
--- 3231,3243 ----
  	GS *gp;
  	VCS cs;
  	MARK m;
+ #ifndef MULTIBYTE
  	int cnt, endc, startc;
+ #else
+ 	/* why endc and startc has to be int? */
+ 	int cnt;
+ 	CHAR_T endc, startc;
+ #endif /*MULTIBYTE*/
  
  	gp = sp->gp;
  
***************
*** 2771,2777 ****
--- 3265,3275 ----
  
  	/* Search for the match. */
  	for (cnt = 1;;) {
+ #ifndef MULTIBYTE
  		if (cs_prev(sp, &cs))
+ #else
+ 		if (cs_multi_prev(sp, &cs))
+ #endif
  			return (1);
  		if (cs.cs_flags != 0) {
  			if (cs.cs_flags == CS_EOF || cs.cs_flags == CS_SOF) {
***************
*** 2813,2821 ****
--- 3311,3329 ----
  {
  	VI_PRIVATE *vip;
  	size_t len, off;
+ #ifndef MULTIBYTE
  	char *p, *wp;
+ #else
+ 	CHAR_T *p, *wp;
+ #endif
+ #ifdef MULTIBYTE
+ 	size_t mback;
+ 	int western;
+ 	u_int ochclass, chclass;
+ #endif
  
  	/* Find the nearest previous blank. */
+ #ifndef MULTIBYTE
  	for (off = tp->cno - 1, p = tp->lb + off, len = 0;; --off, --p, ++len) {
  		if (isblank(*p)) {
  			wp = p + 1;
***************
*** 2836,2841 ****
--- 3344,3396 ----
  			return (0);
  		}
  	}
+ #else
+ 	/*
+ 	 * When we divide the words, we have several possibilities.
+ 	 * 1. blank character
+ 	 * 2. word boundary of non-western character stream
+ 	 * 3. boundary between western chars and non-western chars
+ 	 */
+ 	off = tp->cno - multi_back(sp, tp->lb, &tp->lb[tp->cno]);
+ 	p = tp->lb + off;
+ 	western = multi_iswestern(sp, *p);
+ 	ochclass = multi_chclass(p, 0);
+ 	wp = NULL;
+ 	len = 0;
+ 	while (1) {
+ 		chclass = multi_chclass(p, ochclass);
+ 
+ 		if (isblank(*p)) {
+ 			wp = p + 1;
+ 			break;
+ 		}
+ 
+ 		if (multi_Wordbound(ochclass, chclass, 0)) {
+ 			wp = p + KEY_BLEN(sp, *p);
+ 			break;
+ 		}
+ 
+ 		/*
+ 		 * If reach the start of the line, there's nowhere to break.
+ 		 *
+ 		 * !!!
+ 		 * Historic vi belled each time a character was entered after
+ 		 * crossing the margin until a space was entered which could
+ 		 * be used to break the line.  I don't as it tends to wake the
+ 		 * cats.
+ 		 */
+ 		if (off == tp->ai || off == tp->offset) {
+ 			*didbreak = 0;
+ 			return (0);
+ 		}
+ 
+ 		mback = multi_back(sp, tp->lb, &tp->lb[off]);
+ 		off -= mback;
+ 		p -= mback;
+ 		ochclass = chclass;
+ 	}
+ 	len = tp->cno - (wp - tp->lb);
+ #endif /*MULTIBYTE*/
  
  	/*
  	 * Store saved information about the rest of the line in the
***************
*** 2848,2854 ****
--- 3403,3413 ----
  	 * move to the new line.
  	 */
  	vip = VIP(sp);
+ #ifndef MULTIBYTE
  	wmtp->lb = p + 1;
+ #else
+ 	wmtp->lb = wp;
+ #endif
  	wmtp->offset = len;
  	wmtp->insert = LF_ISSET(TXT_APPENDEOL) ?  tp->insert - 1 : tp->insert;
  	wmtp->owrite = tp->owrite;
***************
*** 2868,2873 ****
--- 3427,3433 ----
  	 * !!!
  	 * Delete any trailing whitespace from the current line.
  	 */
+ #ifndef MULTIBYTE
  	for (;; --p, --off) {
  		if (!isblank(*p))
  			break;
***************
*** 2876,2881 ****
--- 3436,3459 ----
  		if (off == tp->ai || off == tp->offset)
  			break;
  	}
+ #else
+ 	while (1) {
+ 		if (!isblank(*p))
+ 			break;
+ 
+ 		mback = multi_back(sp, tp->lb, &tp->lb[tp->cno]);
+ 		tp->cno -= mback;
+ 		mback = multi_back(sp, tp->lb, &tp->lb[tp->len]);
+ 		tp->len -= mback;
+ 
+ 		if (off == tp->ai || off == tp->offset)
+ 			break;
+ 
+ 		mback = multi_back(sp, tp->lb, &tp->lb[off]);
+ 		p -= mback;
+ 		off -= mback;
+ 	}
+ #endif /*MULTIBYTE*/
  	*didbreak = 1;
  	return (0);
  }
***************
*** 2893,2899 ****
--- 3471,3481 ----
  {
  	TEXT *ttp;
  	size_t input_len, retain;
+ #ifndef MULTIBYTE
  	char *p;
+ #else
+ 	CHAR_T *p;
+ #endif
  
  	/*
  	 * Check to make sure that the cursor hasn't moved beyond
***************
*** 2902,2907 ****
--- 3484,3490 ----
  	if (tp->owrite == 0)
  		return;
  
+ #ifndef MULTIBYTE
  	/*
  	 * Calculate how many characters the user has entered,
  	 * plus the blanks erased by <carriage-return>/<newline>s.
***************
*** 2936,2941 ****
--- 3519,3555 ----
  		tp->owrite = 0;
  		tp->insert += retain;
  	}
+ #else
+ 	/*
+ 	 * Since R command in multibyte case does overwrite multibyte char
+ 	 * by 1-byte char (and other way around too), it is not very trivial
+ 	 * to understand the portion of old line buffer to be preserved.
+ 	 *
+ 	 * The key is that we overwrite character by character, regardess
+ 	 * of their bytewidth.  If we sum up the bytewidth, we can understand
+ 	 * how many bytes has been prepared as new text, and how many bytes
+ 	 * has been overwritten by the new text.  We will replace overwritten
+ 	 * portion of the new text string.
+ 	 */
+     {
+ 	size_t ocol;
+ 	size_t olen;
+ 	size_t ncol;
+ 	
+ 	if (db_get(sp,
+ 	    tiqh->cqh_first->lno, DBG_FATAL | DBG_NOCACHE, &p, &olen))
+ 		return;
+ 	ocol = ncol = 0;
+ 	while (ncol < tp->cno) {
+ 		ncol += KEY_BLEN(sp, tp->lb[ncol]);
+ 		ocol += KEY_BLEN(sp, p[ocol]);
+ 	}
+ 	memcpy(tp->lb + tp->cno, p + ocol, olen - ocol);
+ 	tp->len -= tp->owrite - (olen - ocol);
+ 	tp->owrite = 0;
+ 	tp->insert += (olen - ocol);
+     }
+ #endif /*MULTIBYTE*/
  }
  
  /*
Index: vi/v_ulcase.c
Prereq: 	10.7 
*** nvi-1.79/vi/v_ulcase.c	Sun Apr 28 00:21:27 1996
--- nvi-1.79-m17n/vi/v_ulcase.c	Fri Feb 21 22:19:19 1997
***************
*** 54,60 ****
--- 54,67 ----
  	recno_t lno;
  	size_t cno, lcnt, len;
  	u_long cnt;
+ #ifndef MULTIBYTE
  	char *p;
+ #else
+ 	CHAR_T *p;
+ #endif
+ #ifdef MULTIBYTE
+ 	size_t i;
+ #endif
  
  	lno = vp->m_start.lno;
  	cno = vp->m_start.cno;
***************
*** 77,82 ****
--- 84,90 ----
  			continue;
  		}
  
+ #ifndef MULTIBYTE
  		if (cno + cnt >= len) {
  			lcnt = len - 1;
  			cnt -= len - cno;
***************
*** 88,93 ****
--- 96,123 ----
  
  			vp->m_final.cno = lcnt + 1;
  		}
+ #else
+ 	    {
+ 		size_t i;
+ 
+ 		i = 0;
+ 		lcnt = cno;
+ 		while (i < cnt && lcnt < len) {
+ 			i++;
+ 			lcnt += KEY_BLEN(sp, p[lcnt]);
+ 		}
+ 
+ 		if (len <= lcnt) {
+ 			lcnt = len - multi_back(sp, p, &p[len]);
+ 			vp->m_final.cno = lcnt;
+ 			cnt -= i;
+ 		} else {
+ 			vp->m_final.cno = lcnt;
+ 			cnt -= i;
+ 			lcnt -= multi_back(sp, p, &p[lcnt]);
+ 		}
+ 	    }
+ #endif /*MULTIBYTE*/
  
  		if (ulcase(sp, lno, p, len, cno, lcnt))
  			return (1);
***************
*** 169,174 ****
--- 199,214 ----
  			*p = tolower(ch);
  			change = 1;
  		}
+ #ifdef MULTIBYTE
+ 		/*
+ 		 * XXX
+ 		 * there should be a way to define case-conversion function
+ 		 * for multibyte chars.
+ 		 */
+ 		else if (1 < KEY_BLEN(sp, ch)) {
+ 			p += (KEY_BLEN(sp, ch) - 1);	/*1 more at for loop*/
+ 		}
+ #endif
  	}
  
  	if (change && db_set(sp, lno, bp, len))
Index: vi/v_util.c
Prereq: 	10.11 
*** nvi-1.79/vi/v_util.c	Mon Jul  1 06:50:34 1996
--- nvi-1.79-m17n/vi/v_util.c	Thu Feb 20 00:08:37 1997
***************
*** 65,77 ****
--- 65,88 ----
  	MARK *mp;
  {
  	size_t len;
+ #ifdef MULTIBYTE
+ 	char *p;
+ #endif
  
  	if (mp == NULL)
  		v_emsg(sp, NULL, VIM_EOL);
  	else {
+ #ifndef MULTIBYTE
  		if (db_get(sp, mp->lno, DBG_FATAL, NULL, &len))
+ #else
+ 		if (db_get(sp, mp->lno, DBG_FATAL, &p, &len))
+ #endif
  			return;
+ #ifndef MULTIBYTE
  		if (mp->cno == len - 1)
+ #else
+ 		if (mp->cno == len - multi_back(sp, p, &p[len]))
+ #endif
  			v_emsg(sp, NULL, VIM_EOL);
  		else
  			msgq(sp, M_BERR, "196|Movement past the end-of-line");
***************
*** 125,135 ****
--- 136,154 ----
   * v_isempty --
   *	Return if the line contains nothing but white-space characters.
   *
+  * PUBLIC: #ifndef MULTIBYTE
   * PUBLIC: int v_isempty __P((char *, size_t));
+  * PUBLIC: #else
+  * PUBLIC: int v_isempty __P((CHAR_T *, size_t));
+  * PUBLIC: #endif
   */
  int
  v_isempty(p, len)
+ #ifndef MULTIBYTE
  	char *p;
+ #else
+ 	CHAR_T *p;
+ #endif
  	size_t len;
  {
  	for (; len--; ++p)
